Index: issm/branches/trunk-jpl-damage/src/m/model/MatlabFuncs.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/MatlabFuncs.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/MatlabFuncs.py	(revision 12878)
@@ -0,0 +1,47 @@
+def strcmp(s1,s2):
+
+	if s1 == s2:
+		return True
+	else:
+		return False
+
+def strncmp(s1,s2,n):
+
+	if s1[0:n] == s2[0:n]:
+		return True
+	else:
+		return False
+
+def strcmpi(s1,s2):
+
+	if s1.lower() == s2.lower():
+		return True
+	else:
+		return False
+
+def strncmpi(s1,s2,n):
+
+	if s1.lower()[0:n] == s2.lower()[0:n]:
+		return True
+	else:
+		return False
+
+def ismember(a,s):
+	import numpy
+
+	if not isinstance(s,(tuple,list,dict,numpy.ndarray)):
+		s=[s]
+
+	if not isinstance(a,(tuple,list,dict,numpy.ndarray)):
+		a=[a]
+
+	if not isinstance(a,numpy.ndarray):
+		b=[item in s for item in a]
+
+	else:
+		b=numpy.empty_like(a)
+		for i,item in enumerate(a.flat):
+			b.flat[i]=item in s
+
+	return b
+
Index: issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.m	(revision 12878)
@@ -5,5 +5,5 @@
 %      Result=ProcessPatch(Result);
 
-%return if there is no fiel Patch
+%return if there is no field Patch
 if (~isfield(structure,'Patch')),
 	return;
Index: issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/MatlabProcessPatch.py	(revision 12878)
@@ -0,0 +1,19 @@
+def MatlabProcessPatch(structure):
+	"""
+	PROCESSPATCH - create a structure from a patch
+ 
+	    Usage:
+	       Result=ProcessPatch(Result);
+	"""
+
+	#loop over steps
+	for structurei in structure.itervalues():
+
+		#return if there is no field Patch
+		if not 'Patch' in structurei:
+			continue
+
+		raise SystemError("MatlabProcessPatch not implemented in Python.")
+
+	return structure
+
Index: issm/branches/trunk-jpl-damage/src/m/model/ProfileValues.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/ProfileValues.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/ProfileValues.m	(revision 12878)
@@ -0,0 +1,21 @@
+function [Z,data_interp]=ProfileValues(md,data,xprof,yprof,resolution)
+%PROFILEVALUES - compute the value of a field on a vertical profile
+%
+%   This routine gets the value of a given field of the model on points
+%   given by filname (Argus type file)
+%
+%   Usage:
+%      [z,data]=ProfileValues(md,data,filename,resolution)
+%      [z,data]=ProfileValues(md,data,profile_structure,resolution)
+
+%Get bed and surface for each 2d point, offset to make sure that it is inside the glacier system
+offset=10^-3;
+bed=InterpFromMeshToMesh2d(md.mesh.elements2d,md.mesh.x2d,md.mesh.y2d,project2d(md,md.geometry.bed,1),xprof,yprof)+offset;
+surface=InterpFromMeshToMesh2d(md.mesh.elements2d,md.mesh.x2d,md.mesh.y2d,project2d(md,md.geometry.surface,1),xprof,yprof)-offset;
+
+%Some useful parameters
+layers=ceil(mean(md.geometry.thickness)/resolution);
+Z=(bed:resolution:surface)';
+X=xprof*ones(size(Z));
+Y=yprof*ones(size(Z));
+data_interp=InterpFromMeshToMesh3d(md.mesh.elements,md.mesh.x,md.mesh.y,md.mesh.z,data,X,Y,Z,NaN);
Index: issm/branches/trunk-jpl-damage/src/m/model/SectionValues.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/SectionValues.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/SectionValues.m	(revision 12878)
@@ -12,8 +12,8 @@
 if ischar(infile),
 	%read infile:
-	contempt=expread(infile);
-	nods=contempt.nods;
-	x=contempt.x;
-	y=contempt.y;
+	profile=expread(infile);
+	nods=profile.nods;
+	x=profile.x;
+	y=profile.y;
 else
 	%read infile:
Index: issm/branches/trunk-jpl-damage/src/m/model/WriteData.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/WriteData.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/WriteData.m	(revision 12878)
@@ -35,5 +35,5 @@
 %Step 2: write the data itself.
 if     strcmpi(format,'Boolean'),% {{{
-	if(numel(data)~=1), error(['field ' field ' cannot be marshalled as it has more than one element!']); end
+	if(numel(data)~=1), error(['field ' EnumToString(enum) ' cannot be marshalled as it has more than one element!']); end
 
 	%first write length of record
@@ -59,5 +59,5 @@
 	% }}}
 elseif strcmpi(format,'Double'), % {{{
-	if(numel(data)~=1), error(['field ' field ' cannot be marshalled as it has more than one element!']); end
+	if(numel(data)~=1), error(['field ' EnumToString(enum) ' cannot be marshalled as it has more than one element!']); end
 
 	%first write length of record
@@ -233,5 +233,5 @@
 	enum=eval([string 'Enum();']); 
 end % }}}
-function code=FormatToCode(format) % {{{1
+function code=FormatToCode(format) % {{{
 %This routine takes the format string, and hardcodes it into an integer, which 
 %is passed along the record, in order to identify the nature of the dataset being 
Index: issm/branches/trunk-jpl-damage/src/m/model/WriteData.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/WriteData.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/WriteData.py	(revision 12878)
@@ -0,0 +1,274 @@
+import numpy
+import math
+import struct
+from MatlabFuncs import *
+
+def WriteData(fid,*args):
+	"""
+	WRITEDATA - write model field in binary file
+ 
+	    Usage:
+	       WriteData(fid,*args)
+	"""
+
+	#process options
+	options=pairoptions(args)
+
+	#Get data properties
+	if options.exist('object'):
+		#This is an object field, construct enum and data
+		obj       = options.getfieldvalue('object')
+		fieldname = options.getfieldvalue('fieldname')
+		classname = type(obj)
+
+		enum      = BuildEnum(classname+'_'+fieldname)
+		data      = getattr(obj,fieldname)
+	else:
+		#No processing required
+		data = options.getfieldvalue('data')
+		enum = options.getfieldvalue('enum')
+	format  = options.getfieldvalue('format')
+	mattype = options.getfieldvalue('mattype',0)    #only required for matrices
+
+	#Process sparse matrices
+#	if issparse(data),
+#		data=full(data);
+#	end
+
+	#Step 1: write the enum to identify this record uniquely
+	fid.write(struct.pack('i',enum)) 
+
+	#Step 2: write the data itself.
+	if   strcmpi(format,'Boolean'):    # {{{
+		if len(data) !=1:
+			raise ValueError('field %s cannot be marshalled as it has more than one element!' % EnumToString(enum))
+
+		#first write length of record
+		fid.write(struct.pack('i',4+4))  #1 bool (disguised as an int)+code
+
+		#write data code: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+
+		#now write integer
+		fid.write(struct.pack('i',data))  #send an int, not easy to send a bool
+		# }}}
+
+	elif strcmpi(format,'Integer'):    # {{{
+		if len(data) !=1:
+			raise ValueError('field %s cannot be marshalled as it has more than one element!' % EnumToString(enum))
+
+		#first write length of record
+		fid.write(struct.pack('i',4+4))  #1 integer + code
+
+		#write data code: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+
+		#now write integer
+		fid.write(struct.pack('i',data)) 
+		# }}}
+
+	elif strcmpi(format,'Double'):    # {{{
+		if len(data) !=1:
+			raise ValueError('field %s cannot be marshalled as it has more than one element!' % EnumToString(enum))
+
+		#first write length of record
+		fid.write(struct.pack('i',8+4))  #1 double+code
+
+		#write data code: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+
+		#now write double
+		fid.write(struct.pack('d',data)) 
+		# }}}
+
+	elif strcmpi(format,'String'):    # {{{
+		#first write length of record
+		fid.write(struct.pack('i',len(data)+4+4))  #string + string size + code
+
+		#write data code: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+
+		#now write string
+		fid.write(struct.pack('i',len(data))) 
+		fid.write(struct.pack('%ds' % len(data),data)) 
+		# }}}
+
+	elif strcmpi(format,'BooleanMat'):    # {{{
+
+		#Get size
+		s=data.shape
+		#if matrix = NaN, then do not write anything
+		if s[0]==1 and s[1]==1 and math.isnan(data[0][0]):
+			s[0]=0
+			s[1]=0
+
+		#first write length of record
+		fid.write(struct.pack('i',4+4+8*s[0]*s[1]+4+4))    #2 integers (32 bits) + the double matrix + code + matrix type
+
+		#write data code and matrix type: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+		fid.write(struct.pack('i',mattype))
+
+		#now write matrix
+		fid.write(struct.pack('i',s[0])) 
+		fid.write(struct.pack('i',s[1])) 
+		for i in xrange(s[0]):
+			for j in xrange(s[1]):
+				fid.write(struct.pack('i',data[i][j]))    #get to the "c" convention, hence the transpose
+		# }}}
+
+	elif strcmpi(format,'IntMat'):    # {{{
+
+		#Get size
+		s=data.shape
+		#if matrix = NaN, then do not write anything
+		if s[0]==1 and s[1]==1 and math.isnan(data[0][0]):
+			s[0]=0
+			s[1]=0
+
+		#first write length of record
+		fid.write(struct.pack('i',4+4+8*s[0]*s[1]+4+4))    #2 integers (32 bits) + the double matrix + code + matrix type
+
+		#write data code and matrix type: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+		fid.write(struct.pack('i',mattype))
+
+		#now write matrix
+		fid.write(struct.pack('i',s[0])) 
+		fid.write(struct.pack('i',s[1])) 
+		for i in xrange(s[0]):
+			for j in xrange(s[1]):
+				fid.write(struct.pack('i',data[i][j]))    #get to the "c" convention, hence the transpose
+		# }}}
+
+	elif strcmpi(format,'DoubleMat'):    # {{{
+
+		#Get size
+		s=data.shape
+		#if matrix = NaN, then do not write anything
+		if s[0]==1 and s[1]==1 and math.isnan(data[0][0]):
+			s[0]=0
+			s[1]=0
+
+		#first write length of record
+		fid.write(struct.pack('i',4+4+8*s[0]*s[1]+4+4))    #2 integers (32 bits) + the double matrix + code + matrix type
+
+		#write data code and matrix type: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+		fid.write(struct.pack('i',mattype))
+
+		#now write matrix
+		fid.write(struct.pack('i',s[0])) 
+		fid.write(struct.pack('i',s[1])) 
+		for i in xrange(s[0]):
+			for j in xrange(s[1]):
+				fid.write(struct.pack('d',data[i][j]))    #get to the "c" convention, hence the transpose
+		# }}}
+
+	elif strcmpi(format,'MatArray'):    # {{{
+
+		#first get length of record
+		recordlength=4+4    #number of records + code
+		for matrix in data:
+			s=matrix.shape
+			recordlength+=4*2+s[0]*s[1]*8    #row and col of matrix + matrix of doubles
+
+		#write length of record
+		fid.write(struct.pack('i',recordlength)) 
+
+		#write data code: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+
+		#write data, first number of records
+		fid.write(struct.pack('i',len(data))) 
+
+		#write each matrix: 
+		for matrix in data:
+			s=matrix.shape
+			fid.write(struct.pack('i',s[0])) 
+			fid.write(struct.pack('i',s[1])) 
+			for i in xrange(s[0]):
+				for j in xrange(s[1]):
+					fid.write(struct.pack('d',matrix[i][j]))
+		# }}}
+
+	elif strcmpi(format,'StringArray'):    # {{{
+
+		#first get length of record
+		recordlength=4+4    #for length of array + code
+		for string in data:
+			recordlength+=4+len(string)    #for each string
+
+		#write length of record
+		fid.write(struct.pack('i',recordlength)) 
+
+		#write data code: 
+		fid.write(struct.pack('i',FormatToCode(format))) 
+
+		#now write length of string array
+		fid.write(struct.pack('i',len(data))) 
+
+		#now write the strings
+		for string in data:
+			fid.write(struct.pack('i',len(string))) 
+			fid.write(struct.pack('%ds' % len(string),string)) 
+		# }}}
+
+	else:    # {{{
+		raise TypeError('WriteData error message: data type: %d not supported yet! (%s)' % (format,EnumToString(enum)))
+	# }}}
+
+def BuildEnum(string): # {{{
+	"""
+	BUILDENUM - build enum out of string
+ 
+    Usage:
+       enum=BuildEnum(string)
+	"""
+
+	if '_' in string:
+		substrs=string.split('_')
+		string=''
+		for str in substrs:
+			string+=str[0].upper()+str[1:]
+	else:
+		#take first letter of string and make it uppercase: 
+		string=str[0].upper()+str[1:]
+
+	#Get Enum
+	exec('enum='+string+'Enum()',globals())
+
+	return enum
+# }}}
+
+def FormatToCode(format): # {{{
+	"""
+	This routine takes the format string, and hardcodes it into an integer, which 
+	is passed along the record, in order to identify the nature of the dataset being 
+	sent.
+	"""
+
+	if   strcmpi(format,'Boolean'):
+		code=1
+	elif strcmpi(format,'Integer'):
+		code=2
+	elif strcmpi(format,'Double'):
+		code=3
+	elif strcmpi(format,'String'):
+		code=4
+	elif strcmpi(format,'BooleanMat'):
+		code=5
+	elif strcmpi(format,'IntMat'):
+		code=6
+	elif strcmpi(format,'DoubleMat'):
+		code=7
+	elif strcmpi(format,'MatArray'):
+		code=8
+	elif strcmpi(format,'StringArray'):
+		code=9
+	else:
+		raise InputError('FormatToCode error message: data type not supported yet!')
+
+	return code
+# }}}
+
Index: issm/branches/trunk-jpl-damage/src/m/model/addnote.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/addnote.py	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/addnote.py	(revision 12878)
@@ -1,29 +1,25 @@
-def addnote(md, string):
+def addnote(md,string):
+	"""
+	ADDNOTE - add a note to the existing model notes field
+	 
+	    Usage:
+	       md=addnote(md,string);
+	 
+	    Example:
+	       md=addnote(md,'Pine Island, Geometry of 2007');
+	"""
 
-    # Local Variables: md, string, i, notes, miscellaneous, newnotes
-    # Function calls: ischar, nargout, cell, nargin, length, addnote, error
-    #ADDNOTE - add a note to the existing model notes field
-    #
-    #   Usage:
-    #      md=addnote(md,string);
-    #
-    #   Example:
-    #      md=addnote(md,'Pine Island, Geometry of 2007');
-    
-	if not isinstance(string,basetring):
-        print 'addnote error message: second input argument should be a string'
-		return []
-    
-    notes = md.miscellaneous.notes
-    
-	if isinstance(notes,basestring):
+	if not isinstance(string,str):
+		raise TypeError('addnote error message: second input argument should be a string')
+
+	notes=md.miscellaneous.notes
+
+	if isinstance(notes,str):
 		newnotes=[notes,string]
-    else:
-		newnotes=[];
-		for i in range(len(notes)):
-			newnotes=newnotes+notes[i]
-            
-        newnotes=newnotes+nodes;
-        
-    md.miscellaneous.notes = newnotes
-    return md
+	else:
+		newnotes=notes.append(string)
+
+	md.miscellaneous.notes=newnotes
+
+	return md
+
Index: issm/branches/trunk-jpl-damage/src/m/model/averaging.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/averaging.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/averaging.m	(revision 12878)
@@ -1,3 +1,3 @@
-function average=averaging(md,data,iterations)
+function average=averaging(md,data,iterations,varargin)
 %AVERAGING - smooths the input over the mesh
 %
@@ -8,33 +8,61 @@
 %   by taking the average of the element around a node weighted by the
 %   elements volume
+%   For 3d mesh, a last argument can be added to specify the layer to be averaged on.
 %
 %   Usage:
 %      smoothdata=averaging(md,data,iterations)
+%      smoothdata=averaging(md,data,iterations,layer)
 %
 %   Examples:
 %      velsmoothed=averaging(md,md.initialization.vel,4);
 %      pressure=averaging(md,md.initialization.pressure,0);
+%      temperature=averaging(md,md.initialization.temperature,1,1);
 
-if length(data)~=md.mesh.numberofelements & length(data)~=md.mesh.numberofvertices
+if ((nargin~=4) & (nargin~=3)),
+	error('averaging error message');
+end
+if (length(data)~=md.mesh.numberofelements & length(data)~=md.mesh.numberofvertices),
 	error('averaging error message: data not supported yet');
+end
+if md.mesh.dimension==3 & nargin==4,
+	if varargin{1}<=0 | varargin{1}>md.mesh.numberoflayers,
+		error('layer should be between 1 and md.mesh.numberoflayers');
+	end
+	layer=varargin{1};
+else
+	layer=0;
 end
 
 %initialization
-weights=zeros(md.mesh.numberofvertices,1);
-data=data(:);
+if layer==0,
+	weights=zeros(md.mesh.numberofvertices,1);
+	data=data(:);
+else 
+	weights=zeros(md.mesh.numberofvertices2d,1);
+	data=data((layer-1)*md.mesh.numberofvertices2d+1:layer*md.mesh.numberofvertices2d,:);
+end
 
-%load some variables (it is much faster if the variab;es are loaded from md once for all)
-index=md.mesh.elements;
-numberofnodes=md.mesh.numberofvertices;
-numberofelements=md.mesh.numberofelements;
+%load some variables (it is much faster if the variabes are loaded from md once for all)
+if layer==0,
+	index=md.mesh.elements;
+	numberofnodes=md.mesh.numberofvertices;
+	numberofelements=md.mesh.numberofelements;
+else
+	index=md.mesh.elements2d;
+	numberofnodes=md.mesh.numberofvertices2d;
+	numberofelements=md.mesh.numberofelements2d;
+end
 
 %build some variables
 line=index(:);
-if md.mesh.dimension==3
+if md.mesh.dimension==3 & layer==0,
 	rep=6;
 	areas=GetAreas(index,md.mesh.x,md.mesh.y,md.mesh.z);
+elseif md.mesh.dimension==2,
+	rep=3;
+	areas=GetAreas(index,md.mesh.x,md.mesh.y);
 else
 	rep=3;
-	areas=GetAreas(index,md.mesh.x,md.mesh.y);
+	areas=GetAreas(index,md.mesh.x2d,md.mesh.y2d);
 end
 summation=1/rep*ones(rep,1);
Index: issm/branches/trunk-jpl-damage/src/m/model/collapse.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/collapse.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/collapse.m	(revision 12878)
@@ -42,4 +42,5 @@
 if ~isnan(md.initialization.vz),md.initialization.vz=DepthAverage(md,md.initialization.vz);end;
 if ~isnan(md.initialization.vel),md.initialization.vel=DepthAverage(md,md.initialization.vel);end;
+if ~isnan(md.initialization.temperature),md.initialization.temperature=DepthAverage(md,md.initialization.temperature);end;
 
 %bedinfo and surface info
@@ -92,4 +93,5 @@
 md.geometry.thickness=project2d(md,md.geometry.thickness,1);
 md.geometry.bed=project2d(md,md.geometry.bed,1);
+md.geometry.bathymetry=project2d(md,md.geometry.bathymetry,1);
 md.mesh.vertexonboundary=project2d(md,md.mesh.vertexonboundary,1);
 md.mesh.elementconnectivity=project2d(md,md.mesh.elementconnectivity,1);
Index: issm/branches/trunk-jpl-damage/src/m/model/contourenvelope.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/contourenvelope.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/contourenvelope.m	(revision 12878)
@@ -35,8 +35,8 @@
 %Now, build the connectivity tables for this mesh.
 %Computing connectivity
-if size(md.mesh.vertexconnectivity,1)~=md.mesh.numberofvertices,
+if (size(md.mesh.vertexconnectivity,1)~=md.mesh.numberofvertices & size(md.mesh.vertexconnectivity,1)~=md.mesh.numberofvertices2d),
 	md.mesh.vertexconnectivity=NodeConnectivity(md.mesh.elements,md.mesh.numberofvertices);
 end
-if size(md.mesh.elementconnectivity,1)~=md.mesh.numberofelements,
+if (size(md.mesh.elementconnectivity,1)~=md.mesh.numberofelements & size(md.mesh.elementconnectivity,1)~=md.mesh.numberofelements2d),
 	md.mesh.elementconnectivity=ElementConnectivity(md.mesh.elements,md.mesh.vertexconnectivity);
 end
@@ -44,9 +44,24 @@
 %get nodes inside profile
 mesh.elementconnectivity=md.mesh.elementconnectivity;
+if md.mesh.dimension==2;
+	mesh.elements=md.mesh.elements;
+	mesh.x=md.mesh.x;
+	mesh.y=md.mesh.y;
+	mesh.numberofvertices=md.mesh.numberofvertices;
+	mesh.numberofelements=md.mesh.numberofelements;
+else
+	mesh.elements=md.mesh.elements2d;
+	mesh.x=md.mesh.x2d;
+	mesh.y=md.mesh.y2d;
+	mesh.numberofvertices=md.mesh.numberofvertices2d;
+	mesh.numberofelements=md.mesh.numberofelements2d;
+end
+
 if nargin==2,
+
 	if isfile,
 		%get flag list of elements and nodes inside the contour
-		nodein=ContourToMesh(md.mesh.elements,md.mesh.x,md.mesh.y,file,'node',1);
-		elemin=(sum(nodein(md.mesh.elements),2)==size(md.mesh.elements,2));
+		nodein=ContourToMesh(mesh.elements,mesh.x,mesh.y,file,'node',1);
+		elemin=(sum(nodein(mesh.elements),2)==size(mesh.elements,2));
 		%modify element connectivity
 		elemout=find(~elemin);
@@ -55,10 +70,10 @@
 	else
 		%get flag list of elements and nodes inside the contour
-		nodein=zeros(md.mesh.numberofvertices,1); 
-		elemin=zeros(md.mesh.numberofelements,1); 
+		nodein=zeros(mesh.numberofvertices,1); 
+		elemin=zeros(mesh.numberofelements,1); 
 		
 		pos=find(flags); 
 		elemin(pos)=1;
-		nodein(md.mesh.elements(pos,:))=1;
+		nodein(mesh.elements(pos,:))=1;
 
 		%modify element connectivity
@@ -87,11 +102,11 @@
 	els2=mesh.elementconnectivity(el1,find(mesh.elementconnectivity(el1,:)));
 	if length(els2)>1,
-		flag=intersect(md.mesh.elements(els2(1),:),md.mesh.elements(els2(2),:));
-		nods1=md.mesh.elements(el1,:);
+		flag=intersect(mesh.elements(els2(1),:),mesh.elements(els2(2),:));
+		nods1=mesh.elements(el1,:);
 		nods1(find(nods1==flag))=[];
 		segments(count,:)=[nods1 el1];
 
-		ord1=find(nods1(1)==md.mesh.elements(el1,:));
-		ord2=find(nods1(2)==md.mesh.elements(el1,:));
+		ord1=find(nods1(1)==mesh.elements(el1,:));
+		ord2=find(nods1(2)==mesh.elements(el1,:));
 
 		%swap segment nodes if necessary
@@ -104,12 +119,12 @@
 		count=count+1;
 	else
-		nods1=md.mesh.elements(el1,:);
-		flag=setdiff(nods1,md.mesh.elements(els2,:));
+		nods1=mesh.elements(el1,:);
+		flag=setdiff(nods1,mesh.elements(els2,:));
 		for j=1:3,
 			nods=nods1; nods(j)=[];
 			if any(ismember(flag,nods)),
 				segments(count,:)=[nods el1];
-				ord1=find(nods(1)==md.mesh.elements(el1,:));
-				ord2=find(nods(2)==md.mesh.elements(el1,:));
+				ord1=find(nods(1)==mesh.elements(el1,:));
+				ord2=find(nods(2)==mesh.elements(el1,:));
 				if ( (ord1==1 & ord2==2) | (ord1==2 & ord2==3) | (ord1==3 & ord2==1) ),
 					temp=segments(count,1);
Index: issm/branches/trunk-jpl-damage/src/m/model/extrude.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/extrude.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/extrude.m	(revision 12878)
@@ -143,4 +143,5 @@
 md.surfaceforcings.precipitation=project3d(md,'vector',md.surfaceforcings.precipitation,'type','node');
 md.balancethickness.thickening_rate=project3d(md,'vector',md.balancethickness.thickening_rate,'type','node');
+md.surfaceforcings.monthlytemperatures=project3d(md,'vector',md.surfaceforcings.monthlytemperatures,'type','node');
 
 %results
@@ -223,4 +224,7 @@
 if ~isnan(md.inversion.max_parameters),md.inversion.max_parameters=project3d(md,'vector',md.inversion.max_parameters,'type','node');end;
 if ~isnan(md.qmu.partition),md.qmu.partition=project3d(md,'vector',md.qmu.partition','type','node');end
+if(md.surfaceforcings.isdelta18o),md.surfaceforcings.temperatures_lgm=project3d(md,'vector',md.surfaceforcings.temperatures_lgm,'type','node');end
+if(md.surfaceforcings.isdelta18o),md.surfaceforcings.temperatures_presentday=project3d(md,'vector',md.surfaceforcings.temperatures_presentday,'type','node');end
+if(md.surfaceforcings.isdelta18o),md.surfaceforcings.precipitations_presentday=project3d(md,'vector',md.surfaceforcings.precipitations_presentday,'type','node');end
 
 %Put lithostatic pressure if there is an existing pressure
Index: issm/branches/trunk-jpl-damage/src/m/model/ismodelselfconsistent.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/ismodelselfconsistent.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/ismodelselfconsistent.m	(revision 12878)
@@ -6,5 +6,5 @@
 
 %initialize consistency as true
-modelconsistency(true);
+md.private.isconsistent=true;
 
 %Get solution and associated analyses
@@ -12,5 +12,5 @@
 [analyses,numanalyses]=AnalysisConfiguration(solution);
 
-%Go through al model field check that it is a class and call checkconsistency
+%Go through a model field, check that it is a class, and call checkconsistency
 fields=properties('model');
 for i=1:length(fields),
@@ -24,17 +24,17 @@
 	%Check that current field is an object
 	if ~isobject(md.(field))
-		checkmessage(['field ''' char(field) ''' is not an object']);
+		md=checkmessage(md,['field ''' char(field) ''' is not an object']);
 	end
 
 	%Check consistency of the object
 	if verLessThan('matlab', '7.6')
-		checkconsistency(md.(field),md,solution,analyses);
+		md=checkconsistency(md.(field),md,solution,analyses);
 	else
-		md.(field).checkconsistency(md,solution,analyses);
+		md=md.(field).checkconsistency(md,solution,analyses);
 	end
 end
 
 %error message if mode is not consistent
-if modelconsistency==false,
-	error(' ');
+if md.private.isconsistent==false,
+	error('Model not consistent, see messages above');
 end
Index: issm/branches/trunk-jpl-damage/src/m/model/ismodelselfconsistent.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/ismodelselfconsistent.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/ismodelselfconsistent.py	(revision 12878)
@@ -0,0 +1,34 @@
+def ismodelselfconsistent(md):
+	"""
+	ISMODELSELFCONSISTENT - check that model forms a closed form solvable problem.
+
+	    Usage:
+	       ismodelselfconsistent(md),
+	"""
+
+	#initialize consistency as true
+	md.private.isconsistent=true
+
+	#Get solution and associated analyses
+	solution=md.private.solution
+	analyses,numanalyses=AnalysisConfiguration(solution)
+
+	#Go through a model fields, check that it is a class, and call checkconsistency
+	fields=vars('model')
+	for field in fields:
+
+		#Some properties do not need to be checked
+		if field in ['results','debug','radaroverlay']:
+			continue
+
+		#Check that current field is an object
+		if not hasattr(getattr(md,field),'checkconsistency'):
+			md=checkmessage(md,"field '%s' is not an object." % field)
+
+		#Check consistency of the object
+		exec("md.%s.checkconsistency(md,solution,analyses)" % field)
+
+	#error message if mode is not consistent
+	if not md.private.isconsistent:
+		raise RuntimeError('Model not consistent, see messages above.')
+
Index: issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromcluster.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromcluster.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromcluster.m	(revision 12878)
@@ -13,9 +13,17 @@
 
 %Download outputs from the cluster
-if verLessThan('matlab', '7.6');
-	Download(cluster,md);
+filelist={[md.miscellaneous.name '.outlog'],[md.miscellaneous.name '.errlog']};
+if md.qmu.isdakota,
+	filelist{end+1}=[md.miscellaneous.name '.qmu.err'];
+	filelist{end+1}=[md.miscellaneous.name '.qmu.out'];
+	if isfield(md.qmu.params,'tabular_graphics_data'),
+		if md.qmu.params.tabular_graphics_data==true,
+			filelist{end+1}='dakota_tabular.dat';
+		end
+	end
 else
-	cluster.Download(md);
+	filelist{end+1}=[md.miscellaneous.name '.outbin'];
 end
+Download(cluster,md.private.runtimename,filelist);
 
 %If we are here, no errors in the solution sequence, call loadresultsfromdisk.
Index: issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromcluster.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromcluster.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromcluster.py	(revision 12878)
@@ -0,0 +1,61 @@
+import os
+import platform
+import socket
+from MatlabFuncs import *
+
+def loadresultsfromcluster(md,runtimename=False):
+	"""
+	LOADRESULTSFROMCLUSTER - load results of solution sequence from cluster
+ 
+	    Usage:
+	       md=loadresultsfromcluster(md,runtimename);
+	"""
+
+	#retrieve cluster, to be able to call its methods
+	cluster=md.cluster
+
+	if runtimename:
+		md.private.runtimename=runtimename
+	end
+
+	#Download outputs from the cluster
+	filelist=[md.miscellaneous.name+'.outlog',md.miscellaneous.name+'.errlog']
+	if md.qmu.isdakota:
+		filelist.append(md.miscellaneous.name+'.qmu.err')
+		filelist.append(md.miscellaneous.name+'.qmu.out')
+		if 'tabular_graphics_data' in md.qmu.params:
+			if md.qmu.params['tabular_graphics_data']:
+				filelist.append('dakota_tabular.dat')
+		filelist.append(md.miscellaneous.name+'.outbin')
+	Download(cluster,md.private.runtimename,filelist)
+
+	#If we are here, no errors in the solution sequence, call loadresultsfromdisk.
+	md=loadresultsfromdisk(md,md.miscellaneous.name+'.outbin')
+
+	#erase the log and output files
+	if md.qmu.isdakota:
+		os.remove(os.path.join('qmu'+str(os.getpid()),md.miscellaneous.name+'.outlog'))
+		os.remove(os.path.join('qmu'+str(os.getpid()),md.miscellaneous.name+'.errlog'))
+	else:
+		os.remove(md.miscellaneous.name+'.outlog')
+		os.remove(md.miscellaneous.name+'.errlog')
+		os.remove(md.miscellaneous.name+'.outbin')
+		if not 'Windows' in platform.system():
+			os.remove(md.private.runtimename+'.tar.gz')
+
+	#erase input file if run was carried out on same platform.
+	hostname=socket.gethostname().lower().split('.')[0]
+	if strcmpi(hostname,cluster.name):
+		if md.qmu.isdakota:
+			os.remove(os.path.join('qmu'+str(os.getpid()),md.miscellaneous.name+'.bin'))
+			os.remove(os.path.join('qmu'+str(os.getpid()),md.miscellaneous.name+'.queue'))
+		else:
+			os.remove(md.miscellaneous.name+'.bin')
+			os.remove(md.miscellaneous.name+'.petsc')
+			if not 'Windows' in platform.system():
+				os.remove(md.miscellaneous.name+'.queue')
+			else:
+				os.remove(md.miscellaneous.name+'.bat')
+
+	return md
+
